* COMP%
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef comp
        xref cmpel

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err

*
comp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* result = COMP%(X, Y, 0.0.str_cmp.b | 0.0.var_type%.b)
*

        lea.l 3*8(a3),a4        exactly 3 parameters
        cmpa.l a4,a5
        bne.s err_bp

        lea.l 2*8(a3),a4        get last
        exg a4,a3               save a3 for later

        move.w sb.gtint,a2
        jsr (a2)
        bne.s exit


        moveq #0,d5
        move.b (a6,a1.l),d5     string comp type 0..3
        cmpi.b #3,d5
        bgt.s err_bp

        swap d5

        move.b 1(a6,a1.l),d5
        blt.s err_bp            dont support neg

        cmpi.w #$0E,d5
        bgt.s err_bp

        btst #0,d5              odd numbers invalid
        bne.s err_bp

        move.l sb_arthp(a6),d7  save "empty" stack pointer (- 2b)
        movea.l a3,a5
        movea.l a4,a3           bracket first two pars

*
        move.w tab(pc,d5.w),d0
        jsr tab(pc,d0.w)

retint
        move.l d7,sb_arthp(a6)
        movea.l d7,a1
        move.w d0,(a6,a1.l)
        moveq #ar.int,d4
        moveq #0,d0
        rts

*
err_bp
        moveq #err.ipar,d0
*
exit
        rts

*
tab
        dc.w gtint-tab
        dc.w gtint-tab
        dc.w gtint-tab
        dc.w gtint-tab
        dc.w gtlong-tab
        dc.w gtlong-tab
        dc.w gtflt-tab
        dc.w gtstr-tab

*
gtint
        move.w sb.gtint,a2
        jsr (a2)
        bne.s err_exit

        lea.l 2(a1),a0
        bra cmpel

*
gtlong
        move.w sb.gtlin,a2
        jsr (a2)
        bne.s err_exit

        lea.l 4(a1),a0
        bra cmpel

*
gtflt
        move.w sb.gtfp,a2
        jsr (a2)
        bne.s err_exit

        lea.l 6(a1),a0
        bra cmpel

*
gtstr
        move.w sb.gtstr,a2
        jsr (a2)
        bne.s err_exit

        moveq #3,d0
        add.w (a6,a1.l),d0
        bclr #0,d0
        movea.l a1,a0
        lea.l (a0,d0.l),a1      cstr wants it this way around
        bra cmpel

*
err_exit
        addq.l #4,sp
        rts

*
        end
